import { SvelteElement, init, attribute_to_object, safe_not_equal, insert, flush, element, text, space, noop, append, set_data, detach, destroy_each, attr, empty } from "svelte/internal";
import { onMount } from "svelte";
function get_each_context(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[11] = list[i];
  return child_ctx;
}
function get_each_context_1(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[14] = list[i];
  return child_ctx;
}
function create_else_block(ctx) {
  let span;
  let t_value = ctx[14][0] + "";
  let t;
  return {
    c() {
      span = element("span");
      t = text(t_value);
      attr(span, "class", "tag");
    },
    m(target, anchor) {
      insert(target, span, anchor);
      append(span, t);
    },
    p(ctx2, dirty) {
      if (dirty & 1 && t_value !== (t_value = ctx2[14][0] + ""))
        set_data(t, t_value);
    },
    d(detaching) {
      if (detaching)
        detach(span);
    }
  };
}
function create_if_block(ctx) {
  let a;
  let span;
  let t_value = ctx[14][0] + "";
  let t;
  let a_href_value;
  return {
    c() {
      a = element("a");
      span = element("span");
      t = text(t_value);
      attr(span, "class", "tag");
      attr(a, "href", a_href_value = ctx[14][1]);
    },
    m(target, anchor) {
      insert(target, a, anchor);
      append(a, span);
      append(span, t);
    },
    p(ctx2, dirty) {
      if (dirty & 1 && t_value !== (t_value = ctx2[14][0] + ""))
        set_data(t, t_value);
      if (dirty & 1 && a_href_value !== (a_href_value = ctx2[14][1])) {
        attr(a, "href", a_href_value);
      }
    },
    d(detaching) {
      if (detaching)
        detach(a);
    }
  };
}
function create_each_block_1(ctx) {
  let if_block_anchor;
  function select_block_type(ctx2, dirty) {
    if (ctx2[14].length > 1 && ctx2[14][1])
      return create_if_block;
    return create_else_block;
  }
  let current_block_type = select_block_type(ctx);
  let if_block = current_block_type(ctx);
  return {
    c() {
      if_block.c();
      if_block_anchor = empty();
    },
    m(target, anchor) {
      if_block.m(target, anchor);
      insert(target, if_block_anchor, anchor);
    },
    p(ctx2, dirty) {
      if (current_block_type === (current_block_type = select_block_type(ctx2)) && if_block) {
        if_block.p(ctx2, dirty);
      } else {
        if_block.d(1);
        if_block = current_block_type(ctx2);
        if (if_block) {
          if_block.c();
          if_block.m(if_block_anchor.parentNode, if_block_anchor);
        }
      }
    },
    d(detaching) {
      if_block.d(detaching);
      if (detaching)
        detach(if_block_anchor);
    }
  };
}
function create_each_block(ctx) {
  let li;
  let div;
  let span;
  let t0_value = ctx[1].format(ctx[11].date) + "";
  let t0;
  let t1;
  let t2;
  let a;
  let h3;
  let t3_value = ctx[11].title + "";
  let t3;
  let t4;
  let p;
  let t5_value = ctx[11].description + "";
  let t5;
  let a_href_value;
  let t6;
  let li_class_value;
  let each_value_1 = ctx[11].tags;
  let each_blocks = [];
  for (let i = 0; i < each_value_1.length; i += 1) {
    each_blocks[i] = create_each_block_1(get_each_context_1(ctx, each_value_1, i));
  }
  return {
    c() {
      li = element("li");
      div = element("div");
      span = element("span");
      t0 = text(t0_value);
      t1 = space();
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      t2 = space();
      a = element("a");
      h3 = element("h3");
      t3 = text(t3_value);
      t4 = space();
      p = element("p");
      t5 = text(t5_value);
      t6 = space();
      attr(span, "class", "pubdate");
      attr(div, "class", "date-tags");
      attr(a, "class", "link");
      attr(a, "href", a_href_value = ctx[11].href);
      attr(li, "class", li_class_value = ctx[11].tags.reduce(func));
    },
    m(target, anchor) {
      insert(target, li, anchor);
      append(li, div);
      append(div, span);
      append(span, t0);
      append(div, t1);
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].m(div, null);
      }
      append(li, t2);
      append(li, a);
      append(a, h3);
      append(h3, t3);
      append(a, t4);
      append(a, p);
      append(p, t5);
      append(li, t6);
    },
    p(ctx2, dirty) {
      if (dirty & 1 && t0_value !== (t0_value = ctx2[1].format(ctx2[11].date) + ""))
        set_data(t0, t0_value);
      if (dirty & 1) {
        each_value_1 = ctx2[11].tags;
        let i;
        for (i = 0; i < each_value_1.length; i += 1) {
          const child_ctx = get_each_context_1(ctx2, each_value_1, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
          } else {
            each_blocks[i] = create_each_block_1(child_ctx);
            each_blocks[i].c();
            each_blocks[i].m(div, null);
          }
        }
        for (; i < each_blocks.length; i += 1) {
          each_blocks[i].d(1);
        }
        each_blocks.length = each_value_1.length;
      }
      if (dirty & 1 && t3_value !== (t3_value = ctx2[11].title + ""))
        set_data(t3, t3_value);
      if (dirty & 1 && t5_value !== (t5_value = ctx2[11].description + ""))
        set_data(t5, t5_value);
      if (dirty & 1 && a_href_value !== (a_href_value = ctx2[11].href)) {
        attr(a, "href", a_href_value);
      }
      if (dirty & 1 && li_class_value !== (li_class_value = ctx2[11].tags.reduce(func))) {
        attr(li, "class", li_class_value);
      }
    },
    d(detaching) {
      if (detaching)
        detach(li);
      destroy_each(each_blocks, detaching);
    }
  };
}
function create_fragment(ctx) {
  let div;
  let t0;
  let t1_value = ctx[0].length + "";
  let t1;
  let t2;
  let ul;
  let each_value = ctx[0];
  let each_blocks = [];
  for (let i = 0; i < each_value.length; i += 1) {
    each_blocks[i] = create_each_block(get_each_context(ctx, each_value, i));
  }
  return {
    c() {
      div = element("div");
      t0 = text("total: ");
      t1 = text(t1_value);
      t2 = space();
      ul = element("ul");
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      this.c = noop;
    },
    m(target, anchor) {
      insert(target, div, anchor);
      append(div, t0);
      append(div, t1);
      insert(target, t2, anchor);
      insert(target, ul, anchor);
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].m(ul, null);
      }
    },
    p(ctx2, [dirty]) {
      if (dirty & 1 && t1_value !== (t1_value = ctx2[0].length + ""))
        set_data(t1, t1_value);
      if (dirty & 3) {
        each_value = ctx2[0];
        let i;
        for (i = 0; i < each_value.length; i += 1) {
          const child_ctx = get_each_context(ctx2, each_value, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
          } else {
            each_blocks[i] = create_each_block(child_ctx);
            each_blocks[i].c();
            each_blocks[i].m(ul, null);
          }
        }
        for (; i < each_blocks.length; i += 1) {
          each_blocks[i].d(1);
        }
        each_blocks.length = each_value.length;
      }
    },
    i: noop,
    o: noop,
    d(detaching) {
      if (detaching)
        detach(div);
      if (detaching)
        detach(t2);
      if (detaching)
        detach(ul);
      destroy_each(each_blocks, detaching);
    }
  };
}
let CACHE_ARTICLES = "rssfeedcache";
let CACHE_LAST = "rssfeedlastfetch";
function getContent(xmlObj, tagName) {
  return xmlObj.getElementsByTagName(tagName)[0].textContent;
}
const func = (p, c) => `${p} ${c}`;
function instance($$self, $$props, $$invalidate) {
  let { feeds } = $$props;
  let { dedupe = true } = $$props;
  let { cache = true } = $$props;
  let { cachetimeout = 0.03 * 60 * 1e3 } = $$props;
  let { corsproxy = "" } = $$props;
  let { maxperfeed = 5 } = $$props;
  let parsedFeeds = [];
  try {
    parsedFeeds = JSON.parse(feeds);
  } catch (err) {
    console.warn(`Feeds isn't JSON, will try single URL: ${feeds}`, err.message);
  }
  if (!parsedFeeds.length) {
    try {
      const checkURL = new URL(feeds);
      if (checkURL.host && /^https?:/.test(checkURL.protocol))
        parsedFeeds.push(feeds);
      else
        console.warn(`Feed URL: "${feeds}" is malformed, it must be a full URL that starts with https:// or http:// and is otherwise properly shaped`);
    } catch (err) {
      console.warn(`Feed: "${feeds}" is malformed, see docs`, err.message);
    }
  }
  let articles = [];
  let lastFetch = localStorage.getItem(CACHE_LAST) || 0;
  onMount(async () => {
    console.log("mount!");
    const timeDelta = Date.now() - lastFetch;
    if (cache && timeDelta < cachetimeout * 2) {
      $$invalidate(0, articles = JSON.parse(localStorage.getItem(CACHE_ARTICLES)));
      console.log(`${articles.length} articles from ${parseInt(timeDelta / (60 * 1e3))}m old cache`);
      $$invalidate(0, articles = articles.map((a) => {
        a.date = new Date(a.date);
        return a;
      }));
      if (timeDelta < cachetimeout) {
        console.log("cached articles are fresh");
        return;
      } else {
        console.log("fetching fresh articles");
      }
    }
    await Promise.all(parsedFeeds.map(async (feed) => {
      console.log("fetching:", `${corsproxy}${feed.src}`);
      const response = await fetch(`${corsproxy}${feed.src}`);
      const text2 = await response.text();
      const data = new window.DOMParser().parseFromString(text2, "text/xml");
      let channel = data.getElementsByTagName("channel");
      console.log({ channel, data, text: text2 });
      let items = Array.prototype.slice.call(channel[0].children);
      console.log("items count:", items.length, { items });
      let feedArticleCount = 0;
      items.forEach((item) => {
        if (item.tagName === "item") {
          console.log(feed.tag, "Item:", getContent(item, "title"), { item });
          const titleEl = document.createElement("h3");
          titleEl.innerHTML = getContent(item, "title");
          const titleText = titleEl.innerText;
          const descEl = document.createElement("div");
          descEl.innerHTML = getContent(item, "description");
          const extant = articles.some((a) => a.title === titleText);
          if (dedupe && extant) {
            $$invalidate(0, articles = articles.map((c) => {
              if (c.title === titleText && !c.tags.some((a) => a[0] === feed.tag))
                c.tags.push([feed.tag, feed.taglink]);
              return c;
            }));
            return;
          }
          if (feedArticleCount >= maxperfeed)
            return;
          articles.push({
            "feed": feed.title,
            "title": titleEl.innerText,
            "description": descEl.innerText,
            "href": getContent(item, "link"),
            "date": new Date(getContent(item, "pubDate")),
            "tags": [[feed.tag, feed.taglink]]
          });
          feedArticleCount++;
        }
      });
    }));
    $$invalidate(0, articles = articles.sort((a, b) => b.date - a.date));
    localStorage.setItem(CACHE_ARTICLES, JSON.stringify(articles));
    localStorage.setItem(CACHE_LAST, Date.now());
    console.log("end of mount");
  });
  const dtFormat = new Intl.DateTimeFormat("en", { dateStyle: "medium" });
  $$self.$$set = ($$props2) => {
    if ("feeds" in $$props2)
      $$invalidate(2, feeds = $$props2.feeds);
    if ("dedupe" in $$props2)
      $$invalidate(3, dedupe = $$props2.dedupe);
    if ("cache" in $$props2)
      $$invalidate(4, cache = $$props2.cache);
    if ("cachetimeout" in $$props2)
      $$invalidate(5, cachetimeout = $$props2.cachetimeout);
    if ("corsproxy" in $$props2)
      $$invalidate(6, corsproxy = $$props2.corsproxy);
    if ("maxperfeed" in $$props2)
      $$invalidate(7, maxperfeed = $$props2.maxperfeed);
  };
  $$self.$$.update = () => {
    if ($$self.$$.dirty & 1) {
      articles.length;
    }
  };
  return [articles, dtFormat, feeds, dedupe, cache, cachetimeout, corsproxy, maxperfeed];
}
class Src extends SvelteElement {
  constructor(options) {
    super();
    this.shadowRoot.innerHTML = `<style>a{text-decoration:none}a:hover h3,a:hover span{text-decoration:underline}.link{display:block}h3,p{margin:0.4em 0 0.3em}ul{list-style-type:none;padding:0}.date-tags{margin-top:2em}.pubdate{font-size:0.9em}.tag{font-size:0.7em;margin:0 0.25em;padding:0.2em 0.4em;border-radius:0.2rem;background-color:#CCC7;text-transform:uppercase}</style>`;
    init(this, {
      target: this.shadowRoot,
      props: attribute_to_object(this.attributes),
      customElement: true
    }, instance, create_fragment, safe_not_equal, {
      feeds: 2,
      dedupe: 3,
      cache: 4,
      cachetimeout: 5,
      corsproxy: 6,
      maxperfeed: 7
    }, null);
    if (options) {
      if (options.target) {
        insert(options.target, this, options.anchor);
      }
      if (options.props) {
        this.$set(options.props);
        flush();
      }
    }
  }
  static get observedAttributes() {
    return ["feeds", "dedupe", "cache", "cachetimeout", "corsproxy", "maxperfeed"];
  }
  get feeds() {
    return this.$$.ctx[2];
  }
  set feeds(feeds) {
    this.$$set({ feeds });
    flush();
  }
  get dedupe() {
    return this.$$.ctx[3];
  }
  set dedupe(dedupe) {
    this.$$set({ dedupe });
    flush();
  }
  get cache() {
    return this.$$.ctx[4];
  }
  set cache(cache) {
    this.$$set({ cache });
    flush();
  }
  get cachetimeout() {
    return this.$$.ctx[5];
  }
  set cachetimeout(cachetimeout) {
    this.$$set({ cachetimeout });
    flush();
  }
  get corsproxy() {
    return this.$$.ctx[6];
  }
  set corsproxy(corsproxy) {
    this.$$set({ corsproxy });
    flush();
  }
  get maxperfeed() {
    return this.$$.ctx[7];
  }
  set maxperfeed(maxperfeed) {
    this.$$set({ maxperfeed });
    flush();
  }
}
customElements.define("taocode-rss-display", Src);
export { Src as default };
